import csv

from trytond.pool import Pool
from trytond.transaction import Transaction


pool = Pool()
ShipmentCost = pool.get('account.shipment_cost')
InvoiceLine = pool.get('account.invoice.line')
Shipment = pool.get('stock.shipment.drop')

with open('/tmp/shipment-cost-drop-shipments.csv') as csvfile:
    reader = csv.reader(csvfile, delimiter=',')
    next(reader)
    for row in reader:
        print(row)
        invoice_line = InvoiceLine(int(row[0]))
        if invoice_line.shipment_cost:
            raise ValueError(f"{invoice_line} already set")
        shipments = []
        for shipment_id in row[1].split(';'):
            shipments.append(Shipment(int(shipment_id)))
        shipment_cost = ShipmentCost(
            company=invoice_line.company,
            shipment_drops=shipments,
            invoice_lines=[invoice_line],
            allocation_method='shipment',
            )
        shipment_cost.save()
        ShipmentCost.post([shipment_cost])
Transaction().commit()
